<template>
  <Container
      :should-accept-drop="() => allowsDrop"
      @drop="onDrop"
      class="draggable-item"
      v-bind:class="{
        complete: this.complete,
        empty: this.empty,
        disabled: this.disabled,
        cursor: allowsDrag ?'pointer':null
      }"
  >
    <span v-if="item.data">
      <p>{{this.name}}</p>
    </span>
  </Container>
</template>

<script>
  import {Container} from "vue-smooth-dnd";

  export default {
    name: "Tile",
    props: {
      allowsDrop: Boolean,
      allowsDrag:{
        type: Boolean,
        default: true,
      },
      onDrop: {
        type: Function,
        default: ()=>{}
      },
      item: Object,
    },
    computed:{
      name(){
        if(this.item.id){
          return `${this.item.data} ${this.item.id.substring(0,4).toUpperCase()}`;
        }
        return `${this.item.data}`;
      },
      disabled(){
        return !this.allowsDrop && !this.allowsDrag;
      },
      empty(){
        return !this.item.data && (this.allowsDrop || this.allowsDrag)
      },
      complete(){
        return !!this.item.data && (this.allowsDrop || this.allowsDrag)
      },
    },
    methods: {

    },
    components: {
      Container
    }

  }

</script>


<style>

  p{
    margin: 0.2em;
  }
  .draggable-item {
    display: flex;
    padding: 0.2em 0.5em;
    margin: 0.5em;

    width: 8em;
  }
  .cursor{
    cursor: pointer;
  }

  .complete {
     border: green 1px solid;
   }
  .empty {
    border: red 1px solid;
  }
  .disabled {
    border: gray 1px solid;
  }
</style>
